import { Component, OnInit } from '@angular/core';
import { Router } from "@angular/router";
import { Http } from "@angular/http";
import { LayoutService } from "../layout.service";
import { LocalStorageService, SessionStorageService } from 'ngx-webstorage';


@Component({
  selector: 'jhi-sidebar',
  templateUrl: './sidebar.component.html',
  styles: [
      ` span i{
          margin-right: 10px;
      } `
  ]
})
export class SidebarComponent implements OnInit {
    token: boolean;

  constructor(public router: Router, private http: Http,
              public layoutSer:LayoutService,
              private $localStorage: LocalStorageService,
              private $sessionStorage: SessionStorageService) {
  }

  menuList = [];

  ngOnInit() {
         this.getMenu();
  }

  getMenu(){
      this.layoutSer.getMenu().subscribe(
          (res)=>{
              if(res.errCode == 10000){
                  this.menuList =this.listToTree('id','parentId',res.data);
              }
          }
      )
  }

    exists(list, parentId,myId){
        for(let i=0; i<list.length; i++){
            if(list[i][myId] == parentId){
                return true;
            }
        }
        return false;
    }

    listToTree(myId,pId,list){

        const  nodes = [];
        for(let i=0; i<list.length; i++){
            list[i].checked = false;
            const row = list[i];
            if ( !this.exists(list, row[pId],myId) ){
                nodes.push(row);
            }
        }

        const toDo = [];
        for(let i=0; i<nodes.length; i++){
            toDo.push(nodes[i]);
        }
        while(toDo.length){
            const node = toDo.shift(); // the parent node
            for(let i=0; i<list.length; i++){
                const row = list[i];
                if (row[pId] == node[myId]){
                    if (node.children){
                        node.children.push(row);
                    } else {
                        node.children = [row];
                    }
                    toDo.push(row);
                }
            }
        }
        return nodes;
    }
    //简单使用

    openHandler(value: string): void {
        for (const key in this.menuList) {
            if (key !== value) {
                this.menuList[ key ].checked = false;
            }
        }
    }

    goTo(route){
        this.router.navigate([route]);
    }
}
